Loading...
Searching...
No Matches
pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT > Class Template Reference
Module sample_consensus

SampleConsensusModelNormalParallelPlane defines a model for 3D plane segmentation using additional surface normal constraints. More...

`#include <pcl/sample_consensus/sac_model_normal_parallel_plane.h>`

Inheritance diagram for pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >:

## Public Types

using | PointCloud = typename SampleConsensusModel<PointT>::PointCloud
using | PointCloudPtr = typename SampleConsensusModel<PointT>::PointCloudPtr
using | PointCloudConstPtr = typename SampleConsensusModel<PointT>::PointCloudConstPtr
using | PointCloudNPtr = typename SampleConsensusModelFromNormals<PointT, PointNT>::PointCloudNPtr
using | PointCloudNConstPtr = typename SampleConsensusModelFromNormals<PointT, PointNT>::PointCloudNConstPtr
using | Ptr = shared_ptr<SampleConsensusModelNormalParallelPlane<PointT, PointNT> >
using | ConstPtr = shared_ptr<const SampleConsensusModelNormalParallelPlane<PointT, PointNT>>
Public Types inherited from pcl::SampleConsensusModelNormalPlane< PointT, PointNT >
using | PointCloud = typename SampleConsensusModel<PointT>::PointCloud
using | PointCloudPtr = typename SampleConsensusModel<PointT>::PointCloudPtr
using | PointCloudConstPtr = typename SampleConsensusModel<PointT>::PointCloudConstPtr
using | PointCloudNPtr = typename SampleConsensusModelFromNormals<PointT, PointNT>::PointCloudNPtr
using | PointCloudNConstPtr = typename SampleConsensusModelFromNormals<PointT, PointNT>::PointCloudNConstPtr
using | Ptr = shared_ptr<SampleConsensusModelNormalPlane<PointT, PointNT> >
using | ConstPtr = shared_ptr<const SampleConsensusModelNormalPlane<PointT, PointNT>>
Public Types inherited from pcl::SampleConsensusModelPlane< PointT >
using | PointCloud = typename SampleConsensusModel<PointT>::PointCloud
using | PointCloudPtr = typename SampleConsensusModel<PointT>::PointCloudPtr
using | PointCloudConstPtr = typename SampleConsensusModel<PointT>::PointCloudConstPtr
using | Ptr = shared_ptr<SampleConsensusModelPlane<PointT> >
using | ConstPtr = shared_ptr<const SampleConsensusModelPlane<PointT>>
Public Types inherited from pcl::SampleConsensusModel< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointCloudPtr = typename PointCloud::Ptr
using | SearchPtr = typename pcl::search::Search<PointT>::Ptr
using | Ptr = shared_ptr<SampleConsensusModel<PointT> >
using | ConstPtr = shared_ptr<const SampleConsensusModel<PointT> >
Public Types inherited from pcl::SampleConsensusModelFromNormals< PointT, PointNT >
using | PointCloudNConstPtr = typename pcl::PointCloud<PointNT>::ConstPtr
using | PointCloudNPtr = typename pcl::PointCloud<PointNT>::Ptr
using | Ptr = shared_ptr<SampleConsensusModelFromNormals<PointT, PointNT> >
using | ConstPtr = shared_ptr<const SampleConsensusModelFromNormals<PointT, PointNT> >

## Public Member Functions

| SampleConsensusModelNormalParallelPlane (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModelNormalParallelPlane.
| SampleConsensusModelNormalParallelPlane (const PointCloudConstPtr &cloud, const Indices &indices, bool random=false)
| Constructor for base SampleConsensusModelNormalParallelPlane.
| ~SampleConsensusModelNormalParallelPlane () override=default
| Empty destructor.
void | setAxis (const Eigen::Vector3f &ax)
| Set the axis along which we need to search for a plane perpendicular to.
Eigen::Vector3f | getAxis () const
| Get the axis along which we need to search for a plane perpendicular to.
void | setEpsAngle (const double ea)
| Set the angle epsilon (delta) threshold.
double | getEpsAngle () const
| Get the angle epsilon (delta) threshold.
void | setDistanceFromOrigin (const double d)
| Set the distance we expect the plane to be from the origin.
double | getDistanceFromOrigin () const
| Get the distance of the plane from the origin.
void | setEpsDist (const double delta)
| Set the distance epsilon (delta) threshold.
double | getEpsDist () const
| Get the distance epsilon (delta) threshold.
pcl::SacModel | getModelType () const override
| Return a unique id for this model (SACMODEL_NORMAL_PARALLEL_PLANE).
Public Member Functions inherited from pcl::SampleConsensusModelNormalPlane< PointT, PointNT >
| SampleConsensusModelNormalPlane (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModelNormalPlane.
| SampleConsensusModelNormalPlane (const PointCloudConstPtr &cloud, const Indices &indices, bool random=false)
| Constructor for base SampleConsensusModelNormalPlane.
| ~SampleConsensusModelNormalPlane () override=default
| Empty destructor.
void | selectWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold, Indices &inliers) override
| Select all the points which respect the given model coefficients as inliers.
std::size_t | countWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold) const override
| Count all the points which respect the given model coefficients as inliers.
void | getDistancesToModel (const Eigen::VectorXf &model_coefficients, std::vector< double > &distances) const override
| Compute all distances from the cloud data to a given plane model.
pcl::SacModel | getModelType () const override
| Return a unique id for this model (SACMODEL_NORMAL_PLANE).
Public Member Functions inherited from pcl::SampleConsensusModelPlane< PointT >
| SampleConsensusModelPlane (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModelPlane.
| SampleConsensusModelPlane (const PointCloudConstPtr &cloud, const Indices &indices, bool random=false)
| Constructor for base SampleConsensusModelPlane.
| ~SampleConsensusModelPlane () override=default
| Empty destructor.
bool | computeModelCoefficients (const Indices &samples, Eigen::VectorXf &model_coefficients) const override
| Check whether the given index samples can form a valid plane model, compute the model coefficients from these samples and store them internally in model_coefficients_.
void | getDistancesToModel (const Eigen::VectorXf &model_coefficients, std::vector< double > &distances) const override
| Compute all distances from the cloud data to a given plane model.
void | selectWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold, Indices &inliers) override
| Select all the points which respect the given model coefficients as inliers.
std::size_t | countWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold) const override
| Count all the points which respect the given model coefficients as inliers.
void | optimizeModelCoefficients (const Indices &inliers, const Eigen::VectorXf &model_coefficients, Eigen::VectorXf &optimized_coefficients) const override
| Recompute the plane coefficients using the given inlier set and return them to the user.
void | projectPoints (const Indices &inliers, const Eigen::VectorXf &model_coefficients, PointCloud &projected_points, bool copy_data_fields=true) const override
| Create a new point cloud with inliers projected onto the plane model.
bool | doSamplesVerifyModel (const std::set< index_t > &indices, const Eigen::VectorXf &model_coefficients, const double threshold) const override
| Verify whether a subset of indices verifies the given plane model coefficients.
pcl::SacModel | getModelType () const override
| Return a unique id for this model (SACMODEL_PLANE).
Public Member Functions inherited from pcl::SampleConsensusModel< PointT >
| SampleConsensusModel (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModel.
| SampleConsensusModel (const PointCloudConstPtr &cloud, const Indices &indices, bool random=false)
| Constructor for base SampleConsensusModel.
virtual | ~SampleConsensusModel ()=default
| Destructor for base SampleConsensusModel.
virtual void | getSamples (int &iterations, Indices &samples)
| Get a set of random data samples and return them as point indices.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset.
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
void | setIndices (const Indices &indices)
| Provide the vector of indices that represents the input data.
IndicesPtr | getIndices () const
| Get a pointer to the vector of indices used.
const std::string & | getClassName () const
| Get a string representation of the name of this class.
unsigned int | getSampleSize () const
| Return the size of a sample from which the model is computed.
unsigned int | getModelSize () const
| Return the number of coefficients in the model.
void | setRadiusLimits (const double &min_radius, const double &max_radius)
| Set the minimum and maximum allowable radius limits for the model (applicable to models that estimate a radius).
void | getRadiusLimits (double &min_radius, double &max_radius) const
| Get the minimum and maximum allowable radius limits for the model as set by the user.
void | setModelConstraints (std::function< bool(const Eigen::VectorXf &)> function)
| This can be used to impose any kind of constraint on the model, e.g.
void | setSamplesMaxDist (const double &radius, SearchPtr search)
| Set the maximum distance allowed when drawing random samples.
void | getSamplesMaxDist (double &radius) const
| Get maximum distance allowed when drawing random samples.
double | computeVariance (const std::vector< double > &error_sqr_dists) const
| Compute the variance of the errors to the model.
double | computeVariance () const
| Compute the variance of the errors to the model from the internally estimated vector of distances.
Public Member Functions inherited from pcl::SampleConsensusModelFromNormals< PointT, PointNT >
| SampleConsensusModelFromNormals ()
| Empty constructor for base SampleConsensusModelFromNormals.
virtual | ~SampleConsensusModelFromNormals ()=default
| Destructor.
void | setNormalDistanceWeight (const double w)
| Set the normal angular distance weight.
double | getNormalDistanceWeight () const
| Get the normal angular distance weight.
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset.
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset.

## Protected Member Functions

bool | isModelValid (const Eigen::VectorXf &model_coefficients) const override
| Check whether a model is valid given the user constraints.
Protected Member Functions inherited from pcl::SampleConsensusModelNormalPlane< PointT, PointNT >
std::size_t | countWithinDistanceStandard (const Eigen::VectorXf &model_coefficients, const double threshold, std::size_t i=0) const
| This implementation uses no SIMD instructions.
Protected Member Functions inherited from pcl::SampleConsensusModelPlane< PointT >
std::size_t | countWithinDistanceStandard (const Eigen::VectorXf &model_coefficients, const double threshold, std::size_t i=0) const
| This implementation uses no SIMD instructions.
Protected Member Functions inherited from pcl::SampleConsensusModel< PointT >
| SampleConsensusModel (bool random=false)
| Empty constructor for base SampleConsensusModel.
void | drawIndexSample (Indices &sample)
| Fills a sample array with random samples from the indices_ vector.
void | drawIndexSampleRadius (Indices &sample)
| Fills a sample array with one random sample from the indices_ vector and other random samples that are closer than samples_radius_.
int | rnd ()
| Boost-based random number generator.

## Additional Inherited Members

Protected Attributes inherited from pcl::SampleConsensusModel< PointT >
std::string | model_name_
| The model name.
PointCloudConstPtr | input_
| A boost shared pointer to the point cloud data array.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
double | radius_min_
| The minimum and maximum radius limits for the model.
double | radius_max_
double | samples_radius_
| The maximum distance of subsequent samples from the first (radius search).
SearchPtr | samples_radius_search_
| The search object for picking subsequent samples using radius search.
Indices | shuffled_indices_
| Data containing a shuffled version of the indices.
boost::mt19937 | rng_alg_
| Boost-based random number generator algorithm.
std::shared_ptr< boost::uniform_int<> > | rng_dist_
| Boost-based random number generator distribution.
std::shared_ptr< boost::variate_generator< boost::mt19937 &, boost::uniform_int<> > > | rng_gen_
| Boost-based random number generator.
std::vector< double > | error_sqr_dists_
| A vector holding the distances to the computed model.
unsigned int | sample_size_
| The size of a sample from which the model is computed.
unsigned int | model_size_
| The number of coefficients in the model.
std::function< bool(const Eigen::VectorXf &)> | custom_model_constraints_
| A user defined function that takes model coefficients and returns whether the model is acceptable or not.
Protected Attributes inherited from pcl::SampleConsensusModelFromNormals< PointT, PointNT >
double | normal_distance_weight_ {0.0}
| The relative weight (between 0 and 1) to give to the angular distance (0 to pi/2) between point normals and the plane normal.
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset.
Static Protected Attributes inherited from pcl::SampleConsensusModel< PointT >
static const unsigned int | max_sample_checks_ = 1000
| The maximum number of samples to try until we get a good one.

## Detailed Description

template<typename PointT, typename PointNT>
class pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >

SampleConsensusModelNormalParallelPlane defines a model for 3D plane segmentation using additional surface normal constraints.

Basically this means that checking for inliers will not only involve a "distance to model" criterion, but also an additional "maximum angular deviation" between the plane's normal and the inlier points normals. In addition, the plane normal must lie parallel to a user-specified axis. This means that the plane itself will lie perpendicular to that axis, similar to SACMODEL_PERPENDICULAR_PLANE .

The model coefficients are defined as:

- a : the X coordinate of the plane's normal (normalized)
- b : the Y coordinate of the plane's normal (normalized)
- c : the Z coordinate of the plane's normal (normalized)
- d : the fourth Hessian component of the plane's equation

To set the influence of the surface normals in the inlier estimation process, set the normal weight (0.0-1.0), e.g.:

SampleConsensusModelNormalPlane<pcl::PointXYZ, pcl::Normal> sac_model;
...
sac_model.setNormalDistanceWeight (0.1);
...
pcl::SampleConsensusModelNormalPlane::SampleConsensusModelNormalPlane
SampleConsensusModelNormalPlane(const PointCloudConstPtr &cloud, bool random=false)
Constructor for base SampleConsensusModelNormalPlane.
Definition sac_model_normal_plane.h:101

In addition, the user can specify more constraints, such as:

- an axis along which we need to search for a plane perpendicular to (setAxis);
- an angle tolerance threshold between the plane's normal and the above given axis (setEpsAngle);
- a distance we expect the plane to be from the origin (setDistanceFromOrigin);
- a distance tolerance as the maximum allowed deviation from the above given distance from the origin (setEpsDist).

Note
  Please remember that you need to specify an angle > 0 in order to activate the axis-angle constraint!

Author
  Radu B. Rusu and Jared Glover and Nico Blodow

Definition at line 86 of file sac_model_normal_parallel_plane.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT, typename PointNT>

using pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::ConstPtr = shared_ptr<const SampleConsensusModelNormalParallelPlane<PointT, PointNT>>

Definition at line 104 of file sac_model_normal_parallel_plane.h.

## PointCloud

template<typename PointT, typename PointNT>

using pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::PointCloud = typename SampleConsensusModel<PointT>::PointCloud

Definition at line 96 of file sac_model_normal_parallel_plane.h.

## PointCloudConstPtr

template<typename PointT, typename PointNT>

using pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::PointCloudConstPtr = typename SampleConsensusModel<PointT>::PointCloudConstPtr

Definition at line 98 of file sac_model_normal_parallel_plane.h.

## PointCloudNConstPtr

template<typename PointT, typename PointNT>

using pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::PointCloudNConstPtr = typename SampleConsensusModelFromNormals<PointT, PointNT>::PointCloudNConstPtr

Definition at line 101 of file sac_model_normal_parallel_plane.h.

## PointCloudNPtr

template<typename PointT, typename PointNT>

using pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::PointCloudNPtr = typename SampleConsensusModelFromNormals<PointT, PointNT>::PointCloudNPtr

Definition at line 100 of file sac_model_normal_parallel_plane.h.

## PointCloudPtr

template<typename PointT, typename PointNT>

using pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::PointCloudPtr = typename SampleConsensusModel<PointT>::PointCloudPtr

Definition at line 97 of file sac_model_normal_parallel_plane.h.

## Ptr

template<typename PointT, typename PointNT>

using pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::Ptr = shared_ptr<SampleConsensusModelNormalParallelPlane<PointT, PointNT> >

Definition at line 103 of file sac_model_normal_parallel_plane.h.

## Constructor & Destructor Documentation

## SampleConsensusModelNormalParallelPlane() [1/2]

template<typename PointT, typename PointNT>

pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::SampleConsensusModelNormalParallelPlane | ( | const PointCloudConstPtr & | cloud,
|  | bool | random = false )

inline

Constructor for base SampleConsensusModelNormalParallelPlane.

Parameters

  [in] | cloud | the input point cloud dataset
  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 110 of file sac_model_normal_parallel_plane.h.

References pcl::SampleConsensusModel< PointT >::model_name_, pcl::SampleConsensusModel< PointT >::model_size_, pcl::SampleConsensusModel< PointT >::sample_size_, and pcl::SampleConsensusModelNormalPlane< PointT, PointNT >::SampleConsensusModelNormalPlane().

## SampleConsensusModelNormalParallelPlane() [2/2]

template<typename PointT, typename PointNT>

pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::SampleConsensusModelNormalParallelPlane | ( | const PointCloudConstPtr & | cloud,
|  | const Indices & | indices,
|  | bool | random = false )

inline

Constructor for base SampleConsensusModelNormalParallelPlane.

Parameters

  [in] | cloud | the input point cloud dataset
  [in] | indices | a vector of point indices to be used from cloud
  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 129 of file sac_model_normal_parallel_plane.h.

References pcl::SampleConsensusModel< PointT >::model_name_, pcl::SampleConsensusModel< PointT >::model_size_, pcl::SampleConsensusModel< PointT >::sample_size_, and pcl::SampleConsensusModelNormalPlane< PointT, PointNT >::SampleConsensusModelNormalPlane().

## ~SampleConsensusModelNormalParallelPlane()

template<typename PointT, typename PointNT>

pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::~SampleConsensusModelNormalParallelPlane | ( |  | ) |

override default

Empty destructor.

## Member Function Documentation

## getAxis()

template<typename PointT, typename PointNT>

Eigen::Vector3f pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::getAxis | ( |  | ) | const

inline

Get the axis along which we need to search for a plane perpendicular to.

Definition at line 155 of file sac_model_normal_parallel_plane.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## getDistanceFromOrigin()

template<typename PointT, typename PointNT>

double pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::getDistanceFromOrigin | ( |  | ) | const

inline

Get the distance of the plane from the origin.

Definition at line 176 of file sac_model_normal_parallel_plane.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## getEpsAngle()

template<typename PointT, typename PointNT>

double pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::getEpsAngle | ( |  | ) | const

inline

Get the angle epsilon (delta) threshold.

Definition at line 166 of file sac_model_normal_parallel_plane.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## getEpsDist()

template<typename PointT, typename PointNT>

double pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::getEpsDist | ( |  | ) | const

inline

Get the distance epsilon (delta) threshold.

Definition at line 186 of file sac_model_normal_parallel_plane.h.

## getModelType()

template<typename PointT, typename PointNT>

pcl::SacModel pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::getModelType | ( |  | ) | const

inline override virtual

Return a unique id for this model (SACMODEL_NORMAL_PARALLEL_PLANE).

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 190 of file sac_model_normal_parallel_plane.h.

References pcl::SACMODEL_NORMAL_PARALLEL_PLANE.

## isModelValid()

template<typename PointT, typename PointNT>

bool pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::isModelValid | ( | const Eigen::VectorXf & | model_coefficients | ) | const

override protected virtual

Check whether a model is valid given the user constraints.

Parameters

  [in] | model_coefficients | the set of model coefficients

Reimplemented from pcl::SampleConsensusModel< PointT >.

Definition at line 48 of file sac_model_normal_parallel_plane.hpp.

References pcl::SampleConsensusModel< PointT >::isModelValid().

## setAxis()

template<typename PointT, typename PointNT>

void pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::setAxis | ( | const Eigen::Vector3f & | ax | ) |

inline

Set the axis along which we need to search for a plane perpendicular to.

Parameters

  [in] | ax | the axis along which we need to search for a plane perpendicular to

Definition at line 151 of file sac_model_normal_parallel_plane.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## setDistanceFromOrigin()

template<typename PointT, typename PointNT>

void pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::setDistanceFromOrigin | ( | const double | d | ) |

inline

Set the distance we expect the plane to be from the origin.

Parameters

  [in] | d | distance from the template plane to the origin

Definition at line 172 of file sac_model_normal_parallel_plane.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## setEpsAngle()

template<typename PointT, typename PointNT>

void pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::setEpsAngle | ( | const double | ea | ) |

inline

Set the angle epsilon (delta) threshold.

Parameters

  [in] | ea | the maximum allowed deviation from 90 degrees between the plane normal and the given axis.

Note
  You need to specify an angle > 0 in order to activate the axis-angle constraint!

Definition at line 162 of file sac_model_normal_parallel_plane.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## setEpsDist()

template<typename PointT, typename PointNT>

void pcl::SampleConsensusModelNormalParallelPlane< PointT, PointNT >::setEpsDist | ( | const double | delta | ) |

inline

Set the distance epsilon (delta) threshold.

Parameters

  [in] | delta | the maximum allowed deviation from the template distance from the origin

Definition at line 182 of file sac_model_normal_parallel_plane.h.

The documentation for this class was generated from the following files:

- pcl/sample_consensus/sac_model_normal_parallel_plane.h
- pcl/sample_consensus/impl/sac_model_normal_parallel_plane.hpp